/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */

package xlogo.kernel;
import java.awt.Toolkit;
import java.awt.MediaTracker;
import java.awt.geom.GeneralPath;
import java.awt.Color;
import java.awt.Image;
import java.awt.BasicStroke;
import xlogo.Config;
import xlogo.utils.Utils;
import xlogo.Application;
public class Turtle {
	public Color couleurcrayon=Color.black;
	Color couleurmodedessin=Color.black;
	public int id=-1;
	BasicStroke crayon=null;
	int police=12;
	// Image for the turtle
	// If null then draw the triangle
	Image tort=null;  
	GeneralPath triangle;
	
	public double cap,corX,corY,angle;


	int largeur=0,hauteur=0,gabarit=0;
	
	private boolean pendown=true;
	private boolean penReverse=false;
	
	private boolean visible=true;
	private int shape=Config.activeTurtle;
	private float penWidth=0; // half of the pen width 	
  public Turtle(Application cadre){
  	fixe_taille_crayon(1);
  	String chemin="tortue"+Config.activeTurtle+".png";
  	couleurcrayon=Config.pencolor;
  	couleurmodedessin=Config.pencolor;
	if (Config.activeTurtle==0) {
		tort=null;
		largeur=26;
		hauteur=26;
	}
	else {
		//ON teste tout d'abord si le chemin est valide
		if (null==Utils.class.getResource(chemin)) chemin="tortue1.png";
		tort = Toolkit.getDefaultToolkit().getImage(Utils.class.getResource(chemin));
		MediaTracker tracker=new MediaTracker(cadre);
		tracker.addImage(tort,0);
		try{tracker.waitForID(0);}
		catch(InterruptedException e1){}
		largeur = tort.getWidth(cadre);
		hauteur = tort.getHeight(cadre);
		double largeur_ecran=Toolkit.getDefaultToolkit().getScreenSize().getWidth(); 
		// On fait attention à la résolution de l'utilisateur
		double facteur = largeur_ecran/1024.0;
		if ((int)(facteur+0.001)!=1){
			tort=tort.getScaledInstance((int)(facteur*largeur),(int)(facteur*hauteur),Image.SCALE_SMOOTH);
			tracker=new MediaTracker(cadre);
			tracker.addImage(tort,0);
			try{tracker.waitForID(0);}
			catch(InterruptedException e1){}
		}
		largeur = tort.getWidth(cadre);
		hauteur = tort.getHeight(cadre);
	}
	gabarit = Math.max(hauteur, largeur);
    corX=Config.imageWidth/2;
    corY=Config.imageHeight/2;
    angle=Math.PI/2;
    cap=0.0;
  }
  protected void init(){
  	corX=Config.imageWidth/2;
  	corY=Config.imageHeight/2;
  	cap=0.0;
  	angle=Math.PI/2;
  	pendown=true;
  	fixe_taille_crayon(1);
  	couleurcrayon=Config.pencolor;
  	couleurmodedessin=Config.pencolor;
  	penReverse=false;
  }

  void coord(){
    if (null == tort) {
    	if (null==triangle){
    		triangle=new GeneralPath();    	
    	}
    	else triangle.reset();
    	
    	triangle.moveTo((float)(corX - 10.0 * Math.sin(angle)),
    			(float)(corY - 10.0 * Math.cos(angle)));
    	triangle.lineTo((float)(corX + 24.0 * Math.cos(angle)),
    			(float)(corY - 24.0 * Math.sin(angle)));
    	triangle.lineTo((float)(corX + 10.0 * Math.sin(angle)),
    			(float)(corY + 10.0 * Math.cos(angle)));
      	triangle.lineTo((float)(corX - 10.0 * Math.sin(angle)),
    			(float)(corY - 10.0 * Math.cos(angle)));
    }
  }
  public void fixe_taille_crayon(float nb){
  	if (nb<0) nb=1;
  	else if (Config.maxPenWidth!=-1&&nb>Config.maxPenWidth) nb=1;
	if (Config.penShape==0) crayon=new BasicStroke(nb,BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER);
	else crayon=new BasicStroke(nb,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER);
	penWidth=nb / 2;
  }
  public float getPenWidth(){
  	return penWidth;
  }
  protected int getShape(){
  	return shape;
  }
  public void setShape(int id){
  	shape=id;
  }
  protected boolean isVisible(){
  	return visible;
  }
  protected void setVisible(boolean b){
  		visible=b;
  }
  protected boolean isPenDown(){
  	return pendown;
  }
  protected void setPenDown(boolean b){
  		pendown=b;
  }
  protected boolean isPenReverse(){
  	return penReverse;
  }
  protected void setPenReverse(boolean b){
  	penReverse=b;
  }
  
}
